Subject: [netmod] FW: New Version Notification for draft-rwilton-netmod-yang-packages-02.txt

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Thu, 24 Oct 2019 12:31:42 +0000

The third draft document from the versioning design team is the updated YANG packages draft.

IIRC, the significant changes are:
 - re-alignment to the changes in module versioning (e.g. the revision-label/semver split)
 - adding support for checksums (based on SHA-256)
 - locally scoped packages to a device, primarily intended to changed schema changes due to a hotfix/patch to the software.

Feedback/comments on the entire draft is of course helpful/welcome.  But whilst reading the document, there are some specific open questions on which WG feedback is solicited:

1) Should packages use different structures for the file vs the device?

The current approach aims to optimize for readability in the file and data transfer on the device (by reusing YANG library module-sets).

One alternative is to use the same structure on both, with a duplication on module metadata information on the server by not reusing the YANG library module-sets.

2) The new version of the packages draft uses SHA-256 checksums on module, sub-module, and included package definitions.  Normally, a SHA-256 checksum is 64 characters long, but we could allow a prefix of the checksum to optionally be used in the files instead (i.e. similarly to how git commit hashes are handled).

3) Packages are allowed to use "tags" (from draft-ietf-netmod-module-tags) to add extra metadata to a package.  Currently, the draft doesn't provide any mechanism to add, remove, modify the tags associated with a package on a device.  Should this be added, or can this work reasonably be deferred?

4) The package definitions examples don't include/require XML namespaces.  Allowing, but not requiring, these in a package definition seems OK, but I prefer a solution that expects that package and module names to be unique (which, for modules at least, I think that the YANG JSON encoding effectively requires?).

5) I presume that we should try and define an IANA registry for package definitions, similar to the IANA YANG module registry.  Arguably, it might be more useful if the registry could be wider than just IETF modules.

Thanks,
Rob

-----Original Message-----
From: [email-masked] <[email-masked]> 
Sent: 24 October 2019 13:16
To: Rob Wilton (rwilton) <[email-masked]>
Subject: New Version Notification for draft-rwilton-netmod-yang-packages-02.txt

A new version of I-D, draft-rwilton-netmod-yang-packages-02.txt
has been successfully submitted by Robert Wilton and posted to the IETF repository.

Name:		draft-rwilton-netmod-yang-packages
Revision:	02
Title:		YANG Packages
Document date:	2019-10-23
Group:		Individual Submission
Pages:		57
URL:            https://www.ietf.org/internet-drafts/draft-rwilton-netmod-yang-packages-02.txt
Status:         https://datatracker.ietf.org/doc/draft-rwilton-netmod-yang-packages/
Htmlized:       https://tools.ietf.org/html/draft-rwilton-netmod-yang-packages-02
Htmlized:       https://datatracker.ietf.org/doc/html/draft-rwilton-netmod-yang-packages
Diff:           https://www.ietf.org/rfcdiff?url2=draft-rwilton-netmod-yang-packages-02

Abstract:
   This document defines YANG packages, a versioned organizational
   structure holding a set of related YANG modules, that collectively
   define a YANG schema.  It describes how YANG instance data documents
   are used to define YANG packages, and how the YANG library
   information published by a server can be augmented with packages
   related information.

Please note that it may take a couple of minutes from the time of submission until the htmlized version and diff are available at tools.ietf.org.

The IETF Secretariat